package service

import (
	"context"
	"fmt"

	pb "gitlab.com/danialmaki.dm/2_go_layout/pkg/autogenerated"
	"gitlab.com/danialmaki.dm/2_go_layout/pkg/hash"
)

type server struct {
	pb.UnimplementedSubmitServiceServer
	hasher     hash.Hash
	lastNChars string
}

func (s *server) GetNonce(ctx context.Context, req *pb.SubmitRequest,
) (res *pb.SubmitResponse, e error) {
	var nonce int64
	for {
		record, err := s.hasher.GetRecord(req, nonce)
		if err != nil {
			return nil, err
		}
		hashedRecord, err := s.hasher.GetSha256(record)
		if err != nil {
			return nil, err
		}
		if hashedRecord[len(hashedRecord)-len(s.lastNChars):] == s.lastNChars {
			fmt.Println(hashedRecord)
			break
		}
		nonce += 1
	}
	return &pb.SubmitResponse{Nonce: nonce}, nil
}

func New(lastNChars string) pb.SubmitServiceServer {
	return &server{
		hasher:     hash.NewSimpleHash(),
		lastNChars: lastNChars,
	}
}
